PG_RECVLOGICAL(1)

NAME
pg_recvlogical - Control logical decoding (see Chapter 46, Logical Decoding, in the documentation) streams over a walsender connection.

SYNOPSIS

pg_recvlogical [option...]

DESCRIPTION

pg_recvlogical controls logical decoding replication slots and streams data from such replication slots.

It creates a replication-mode connection, so it is subject to the same constraints as pg_receivexlog, plus those for logical replication (see Chapter 46, Logical Decoding, in the documentation).

OPTIONS

pg_recvlogical runs in one of three modes, which control its primary action:

--create-slot
    Create a new logical replication slot with the name specified in --slot, using the output plugin --plugin, then exit. The slot is created for the database given in --dbname.

--start
    Begin streaming changes from the logical replication slot with the name specified in --slot, continuing until terminated with a signal. If the server side change stream ends with a server shutdown or disconnect, retry in a loop unless --no-loop is specified. The stream format is determined by the output plugin specified when the slot was created.

    You must connect to the same database used to create the slot.

--drop-slot
    Drop the replication slot with the name specified in --slot, then exit.

pg_recvlogical supports all the usual libpq-based options. These are explained in detail in the documentation for psql and for libpq.

-U user
--username user
    Username to connect as. Must have a suitable pg_hba.conf entry allowing replication connections. Defaults to current operating system user name.

-d database
--dbname database
    The database to connect to in replication mode; see mode descriptions for details. May be a libpq connstring instead. Defaults to user name.

-h hostname-or-ip
--host hostname-or-ip
    Host or socket to connect to. See psql and libpq documentation.

-p port
--port port
    Port number to connect to. See psql for an explanation of default port choices when this is not specified.

-w
--no-password
    Prevent prompting for a password. Will exit with an error code if a password is required but not available.

-W
--password
    Provide a password for this connection. Please use the pgservice file (see Section 31.16, “The Connection Service File”, in the documentation) or an environment variable instead of this option.

The following command-line options control the location and format of the output and other replication behavior:

-f filename
--file=filename
    Write received and decoded transaction data into this file. Use - for stdout.

-n
--no-loop
    When the connection to the server is lost, do not retry in a loop, just exit.

-o NAME[=VALUE]
--option=NAME[=VALUE]
    Pass the option NAME to the output plugin with, if specified, the option value NAME. Which options exist and their effects depends on the used output plugin.

-F interval_seconds
--fsync-interval=interval_seconds
    How often should pg_recvlogical issue sync commands to ensure the --outputfile is safely flushed to disk without being asked by the server to do so. Specifying an interval of 0 disables issuing fsyncs altogether, while still reporting progress the server. In this case, data may be lost in the event of a crash.

-P plugin
--plugin=plugin
    When creating a slot, use the logical decoding output plugin. See Chapter 46, Logical Decoding, in the documentation. This option has no effect if the slot already exists.

-s interval_seconds
--status-interval=interval_seconds
    This option has the same effect as the option of the same name in pg_receivexlog. See the description there.

-S slot_name
--slot=slot_name
    In --start mode, use the existing logical replication slot named slot_name. In --create-slot mode, create the slot with this name. In --drop-slot mode, delete the slot with this name.

-I lsn
--startpos=lsn
    In --start mode, start replication from the given LSN. For details on the effect of this, see the documentation in Chapter 46, Logical Decoding, in the documentation and Section 49.3, “Streaming Replication Protocol”, in the documentation. Ignored in other modes.

The following additional options are available:

-v
--verbose
    Enables verbose mode.

-V
--version
    Print the pg_recvlogical version and exit.

-?
--help
    Show help about pg_recvlogical command line arguments, and exit.